<?php
function mbot_load(){
	mt_setvar('ingameID', false, 1, 0);
	mt_setvar('ingameLAST', false, 1, 0);
	mt_setvar('ingameLIST', false, 1, 0);
	mb_SelfRegister(MB_EVENT_MSG_IN,1);
	mb_SelfRegister(MB_EVENT_EXTERNAL,1);
	if(setIngamechatContact()){
		mb_MenuAdd('Rescan for ingame', 0, 'ingame_menu', mb_IconLoadSkin(SKINICON_EVENT_URL), 0x00);
	}
	mt_setvar('ingameON', false, 1, 0);
}

//run over Menu if ingamechat contact not yet found
function ingame_menu($parm, $cid, $hmenu){
	if(!setIngamechatContact()){
		mb_MenuModify($hmenu, null, null, 0x04, 'ingame_menu');
	}
}

//sets the ingamechat contact
function setIngamechatContact(){
	$cid = mb_CFindFirst();
	$found = false;
	do{
		if(mb_CGetDisplayName($cid)=="ingamechat"){
			$found = true;
			break;
		}
	}while($cid = mb_CFindNext($cid));
	if($found){
		mt_setvar('ingameID', $cid, 1, 0);
		mb_CSettingAdd($cid, 'CList', DBVT_BYTE, 'Hidden', 1);
		return false;
	}else{
		mb_MsgBox('Contact named ingamechat was not found.
Ingamechat is disabeled.

1. Rename the contact to use to ingamechat.
2. go to menu -> MBot -> Rescan for ingame.', 'Contact not found', 0);
		return true;
	}
}

//xfire plugin detects games
function mbe_External($str,$num){
	if($str=="xfireingame" && mt_getvar('ingameID')!=false){
		ingameOnOff($num);
	}
}




//==================================================================
//messages arrives
//==================================================================

//activity when message arrives
function mbe_MsgIn($cid,$body,$timestamp,$known){
	mb_CSettingAdd(mt_getvar('ingameID'), 'CList', DBVT_BYTE, 'Hidden', 1);
	if(mb_CGetProto($cid)=='MetaContacts')
		return;

	if(mt_getvar('ingameON') && mt_getvar('ingameID') && $cid!=mt_getvar('ingameID')){
		messageFromFriend($cid,regional(trim($body)),$timestamp,$known);
	}elseif(mt_getvar('ingameID')==$cid){
		messageFromIngame($cid,regional(trim($body)),$timestamp,$known);
		return drop;
	}
}

//forewards message to ingame and adds to list
function messageFromFriend($cid,$body,$timestamp,$known){
	if(is_array(mt_getvar('ingameLIST'))){
		$db = mt_getvar('ingameLIST');
	//bereits Kontact gehabt
		if(in_array($cid, $db)){
			foreach($db as $key => $value){
				if($cid==$value){
					$id = $key;
					break;
				}
			}
	//neue cid
		}else{
			$db[] = $cid;
			foreach($db as $key => $value){
				if($cid==$value){
					$id = $key;
					break;
				}
			}
		}
	//erste Nachricht
	}else{
		$db[] = $cid;
		$id = 0;
	}
	mt_setvar('ingameLIST', $db, 1, 1);		
	internMessage(mb_CGetDisplayName($cid).' ('.$id.'): '.$body);
}

//interprets commands from ingame
function messageFromIngame($cid,$body,$timestamp,$known){
	if(strtolower($body)=='ingame'){
		ingameOnOff(!mt_getvar('ingameON'));
	}elseif(strtolower(substr($body,0,3))=='set'){
		renameID($body);
	}elseif(strtolower(substr($body,0,6))=='delete'){
		deleteID($body);
	}elseif(strtolower(substr($body,0,4))=='list'){
		echoList();
	}elseif(strtolower(substr($body,0,6))=='status'){
		echoStatus($body);
	}elseif(strtolower(substr($body,0,5))=='reset'){
		resetList();
	}elseif(strtolower(substr($body,0,5))=='help'){
		echoHelp();
	}elseif(strtolower(substr($body,0,3))=='add'){
		addContact($body);
	}else{
		$pos = strpos($body, ':');
		if($pos === false){
			externMessage($body, mt_getvar('ingameLAST'));
		}elseif($pos == 0){
			$body = trim(substr($body,1));
			externMessage($body, mt_getvar('ingameLAST'));
		}else{
			$id = strtoupper(substr($body, 0, $pos));
			$db = mt_getvar('ingameLIST');
			if(is_array($db) && isset($db[$id])){
				$body = trim(substr($body, $pos+1));
				externMessage($body, $db[$id]);
			}else{
				internMessage('unknown contact '.$id);
			}
		}
	}
}




//==================================================================
//command functions
//==================================================================

//renames contact to new nick
function renameID($body){
	$db = mt_getvar('ingameLIST');
	$input = substr($body,3);
	$pos = strpos($input, '-');
	if($pos == false){
		internMessage('wrong pattern');
	}else{
		$old = trim(substr($input,0,$pos));
		$new = trim(substr($input,$pos+1));
		$new = strtoupper($new);
		if(!isset($db[$old])){
			internMessage('unknown contact '.$old);
		}else{
			$db[$new] = $db[$old];
			unset($db[$old]);
			mt_setvar('ingameLIST', $db, 1, 1);
			internMessage($old.' is now '.$new);
		}
	}
}

//deletes contact nick from list
function deleteID($body){
	$db = mt_getvar('ingameLIST');
	$id = strtoupper(trim(substr($body,6)));
	unset($db[$id]);
	internMessage('no more '.$id.' in list');
	mt_setvar('ingameLIST', $db, 1, 1);
}

//echos current nicklist
function echoList(){
	$db = mt_getvar('ingameLIST');
	$is = false;
	foreach($db as $key => $cid){
		$Status = array(
			ID_STATUS_OFFLINE => "Off",
			0 => "Off",
			ID_STATUS_ONLINE => "On",
			ID_STATUS_AWAY => "Away",
			ID_STATUS_DND => "DND",
			ID_STATUS_NA => "N/A",
			ID_STATUS_OCCUPIED => "Occup",
			ID_STATUS_FREECHAT => "Free",
			ID_STATUS_INVISIBLE => "Invi",
			ID_STATUS_ONTHEPHONE => "phoning",
			ID_STATUS_OUTTOLUNCH => "Lunch",
			ID_STATUS_IDLE => "Idle"
		);
		$is = true;
		internMessage(mb_CGetDisplayName($cid).' ('.$key.') is '.$Status[mb_CGetStatus($cid)].' - '.mb_CGetProto($cid));
	}
	if(mt_getvar('ingameLAST')!=false){
		internMessage('last: '.mb_CGetDisplayName($cid).' is '.$Status[mb_CGetStatus($cid)].' - '.mb_CGetProto($cid));
	}
	if(!$is){
		internMessage('list empty');
	}
}

//echos status of contact
function echoStatus($body){
	$db = mt_getvar('ingameLIST');
	$id = strtoupper(trim(substr($body,7)));
	if(!isset($db[$id])){
		internMessage('unknown contact '.$id);
		return;
	}
	$cid = $db[$id];
	$Status = array(
		ID_STATUS_OFFLINE => "Off",
		0 => "Off",
		ID_STATUS_ONLINE => "On",
		ID_STATUS_AWAY => "Away",
		ID_STATUS_DND => "DND",
		ID_STATUS_NA => "N/A",
		ID_STATUS_OCCUPIED => "Occup",
		ID_STATUS_FREECHAT => "Free",
		ID_STATUS_INVISIBLE => "Invi",
		ID_STATUS_ONTHEPHONE => "phoning",
		ID_STATUS_OUTTOLUNCH => "Lunch",
		ID_STATUS_IDLE => "Idle"
	);
	internMessage(mb_CGetDisplayName($cid).' is '.$Status[mb_CGetStatus($cid)].' - '.mb_CGetProto($cid));
}

//echos current nicklist
function resetList(){
	mt_setvar('ingameLIST', false, 1, 1);
	internMessage('list is empty now');
}

//echos messaging patterns
function echoHelp(){
	internMessage('possible Commands are:
*message* => sends text to contact last send to
:*message* => sends text to contact last send to
*nick*: *message* => send message
status *nick* => returns status
list => lists all nicks
set *nick* - *replacement* => changes nick
add *part of clistname* => adds contact from clist
delete *nick* => deletes nick
reset => deletes all nicks');
}

//turns ingame function on/off
function ingameOnOff($int){
	if($int==1){
		mt_setvar('ingameON', true, 1, 0);
		internMessage('ingame chat is activated');
	}else{
		mt_setvar('ingameON', false, 1, 0);
		internMessage('ingame chat is off');
	}
}

//adds contact to list
function addContact($body){
	$pos = strpos($body, '-');
	$Status = array(
		ID_STATUS_OFFLINE => "Off",
		0 => "Off",
		ID_STATUS_ONLINE => "On",
		ID_STATUS_AWAY => "Away",
		ID_STATUS_DND => "DND",
		ID_STATUS_NA => "N/A",
		ID_STATUS_OCCUPIED => "Occup",
		ID_STATUS_FREECHAT => "Free",
		ID_STATUS_INVISIBLE => "Invi",
		ID_STATUS_ONTHEPHONE => "phoning",
		ID_STATUS_OUTTOLUNCH => "Lunch",
		ID_STATUS_IDLE => "Idle"
	);
	if($pos==false){
		$cid = mb_CFindFirst();
		$searchFor = trim(substr($body,3));
		$found = false;
		do{
			if(stripos(mb_CGetDisplayName($cid),$searchFor)!==false){
				$newContact[] = $cid;
				$found = true;
			}
		}while($cid = mb_CFindNext($cid));
		if($found){
			mt_setvar('ingameAddList', $newContact, 1, 1);
			foreach($newContact as $key => $cid){
				$intern .= $key.': '.mb_CGetDisplayName($cid).' ('.mb_CGetProto($cid).', '.$Status[mb_CGetStatus($cid)].')
';
			}
			internMessage('answer "add *id* - *new nick*" to add contact
'.$intern);
		}else{
			internMessage('No such contact found in Clist');
		}
	}else{
		if(is_array(mt_getvar('ingameAddList'))){
			$db = mt_getvar('ingameAddList');
			$id = trim(substr($body,3,$pos-3));
			if(isset($db[$id])){
				$nick = trim(strtoupper(substr($body,$pos+1)));
				if(is_array(mt_getvar('ingameLIST')))
					$list = mt_getvar('ingameLIST');
				$list[$nick] = $db[$id];
				mt_setvar('ingameLIST', $list, 1, 1);
				internMessage($nick.' was added to list');
			}else{
				internMessage($id.' is not a valid id');
			}
		}else{
			internMessage('Use add *clistname* first');
		}
	}
}



//==================================================================
//send message functions
//==================================================================

//replace regional characters
function regional($body){
	$body = str_replace('ä', '', $body);
	$body = str_replace('ü', '', $body);
	$body = str_replace('ö', '', $body);
	$body = str_replace('ß', '', $body);
	return $body;
}

//callback for sending
function msg_cb($cid,$result,$param){
	if($result == 1){
		//here we will store the msg if sent 
		if($body = mt_getvar("/os/msg/$param")){
			mb_EventAdd(mb_CGetProto($cid),$cid,$body,EVENTTYPE_MESSAGE,0x02,time());
		}
	}else{
		internMessage('Delivery failed');
	}
}

//sends message to friend
function externMessage($body, $cid){
	mt_setvar('ingameLAST', $cid, 1, 0);
	$our_id = time(0);
	mt_setvar("/os/msg/$our_id",$body);
	if(mb_MsgSend($cid, $body, 0, 'msg_cb',$our_id)){
	}else{
		internMessage('Delivery failed');
	}
}

//sends input to ingame contact
function internMessage($body){
	mb_MsgSend(mt_getvar('ingameID'), $body, 0, null, null, 0);
}
?>